/*****************************************************************/
/*                                                               */
/*   CASIO fx-9860G SDK Library                                  */
/*                                                               */
/*   File name : [ProjectName].c                                 */
/*                                                               */
/*   Copyright (c) 2006 CASIO COMPUTER CO., LTD.                 */
/*                                                               */
/*****************************************************************/
#include "fxlib.h"
#include "main.h"

unsigned int key;
int posX = 1;
int posY = 9;
int hasWon;

char currentLvlMap[18][11] = {0};
int mapWidth = 0; //those two ints are for centering the map
int mapHeight = 0;
int posXmap = 0;
int posYmap = 0;

int fileHandle;

int AddIn_main(int isAppli, unsigned short OptionNum) {
	short filename[] = {'\\','\\','f','l','s','0','\\','s','o','k','o','b','a','n','U','.','s','a','v',0};
	fileHandle = Bfile_OpenFile(filename, _OPENMODE_READWRITE);
	if (fileHandle < 0) { //error, file likely does not exist
		fileHandle = Bfile_CreateFile(filename, 180);
		fileHandle = Bfile_OpenFile(filename, _OPENMODE_READWRITE);
	}
	sokobanMenu();

    return 1;
}

void sokobanMenu() {
	while (1) {
		char i;
		char str2[2] = {0};
		char saveData[180] = {0};
		Bfile_ReadFile(fileHandle, &saveData, 170, 0);
		ML_clear_vram();
		ML_vertical_line(0, 8, 63, 1);
		ML_vertical_line(127, 8, 63, 1);
		//ML_rectangle(0, 0, 127, 8, 1, 1, 1);
		ML_horizontal_line(8, 0, 127, 1);
		PrintXY(3, 0, "Choisissez un niveau", 0);
		ML_horizontal_line(63, 0, 127, 1);
		for (i = 0; i < 84; i++) { //displays each number
			char str[2] = {0};
			if (i < 9) {
				str[0] = i+49;
				PrintMini(9*(i%14)+4, 9*(i/14)+11, str, 0);
			} else {
				str[0] = (i+1)/10+48;
				PrintMini(9*(i%14)+2, 9*(i/14)+11, str, 0); //first digit
				str[0] = ((i+1)%10)+48;
				PrintMini(9*(i%14)+6, 9*(i/14)+11, str, 0); //second digit
			}
			if (!saveData[2*i]) {
				/*ML_vertical_line(9*(i%14)+1, 9*(i/14)+9, 9*(i/14)+17, 1);
				ML_vertical_line(9*(i%14)+9, 9*(i/14)+9, 9*(i/14)+17, 1);
				ML_horizontal_line(9*(i/14)+9, 9*(i%14)+1, 9*(i%14)+9, 1);
				ML_horizontal_line(9*(i/14)+17, 9*(i%14)+1, 9*(i%14)+9, 1);*/
				Bdisp_AreaReverseVRAM(9*(i%14)+1, 9*(i/14)+9, 9*(i%14)+9, 9*(i/14)+17);
			}
		}
		do {
			ML_horizontal_line(posY, posX, posX+8, 2);
			ML_horizontal_line(posY+8, posX, posX+8, 2);
			ML_vertical_line(posX, posY+1, posY+7, 2);
			ML_vertical_line(posX+8, posY+1, posY+7, 2);
			//Bdisp_AreaReverseVRAM(posX, posY, posX+8, posY+8);
			GetKey(&key);
			ML_horizontal_line(posY, posX, posX+8, 2);
			ML_horizontal_line(posY+8, posX, posX+8, 2);
			ML_vertical_line(posX, posY+1, posY+7, 2);
			ML_vertical_line(posX+8, posY+1, posY+7, 2);
			//Bdisp_AreaReverseVRAM(posX, posY, posX+8, posY+8);
			if (key == KEY_CTRL_DOWN) {
				posY += 9;
			} else if (key == KEY_CTRL_UP) {
				posY -= 9;
			} else if (key == KEY_CTRL_LEFT) {
				posX -= 9;
			} else if (key == KEY_CTRL_RIGHT) {
				posX += 9;
			}
			if (posY > 60) {
				posY = 9;
			}
			if (posY < 8) {
				posY = 54;
			}
			if (posX < 1) {
				posX = 118;
			}
			if (posX > 120) {
				posX = 1;
			}
		} while (key != KEY_CTRL_EXE);
		/*locate(1,1);
		str2[0] = (posX+8)/9+14*((posY-9)/9)+32;
		Print(str2);
		GetKey(&key);*/
		do {
			sokobanLvl((posX+8)/9+14*((posY-9)/9));
		} while (key == KEY_CTRL_F1 || key == KEY_CTRL_SHIFT || key == KEY_CTRL_EXE);
		if (hasWon) {
			char writeData = 0;
			ML_clear_vram();
			locate(3,4);Print("Vous avez gagn""\xE6\x0A""!");
			ML_display_vram();
			Bfile_SeekFile(fileHandle, 2*((posX+8)/9+14*((posY-9)/9)-1)); //move file cursor
			Bfile_WriteFile(fileHandle, &writeData, 1);
			Sleep(500);
		}
	}
}

void playLvl(char* map) {
	int i,j;
	int posCharX = 0;
	int posCharY = 0;
	hasWon = 0;
	memset(currentLvlMap, 0, sizeof(currentLvlMap));
	ML_clear_vram();
	for (i = 0; i < mapWidth*mapHeight; i++) {
		currentLvlMap[i%mapWidth][i/mapWidth] = map[i];
	}
	posXmap = 64-7*mapWidth/2;
	posYmap = 32-7*mapHeight/2;
	
	//displays the map
	for (i = 0; i < mapWidth; i++) {
		for (j = 0; j < mapHeight; j++) {
			int relativeX = posXmap+7*i;
			int relativeY = posYmap+7*j;
			
			if (currentLvlMap[i][j]) { //sprite isn't a wall
				dispSprite(currentLvlMap[i][j], relativeX, relativeY);
			} else { //draws borders and corners only
			
				if (i > 0 && currentLvlMap[i-1][j]) { //left side
					ML_vertical_line(relativeX, relativeY, relativeY+6, 1);
				}
				if (i < mapWidth && currentLvlMap[i+1][j]) { //right side
					ML_vertical_line(relativeX+6, relativeY, relativeY+6, 1);
				}
				if (j > 0 && currentLvlMap[i][j-1]) { //top side
					ML_horizontal_line(relativeY, relativeX, relativeX+6, 1);
				}
				if (j < mapHeight && currentLvlMap[i][j+1]) { //bottom side
					ML_horizontal_line(relativeY+6, relativeX, relativeX+6, 1);
				}
				if (j > 0 && i > 0 && currentLvlMap[i-1][j-1]) { //top left corner
					ML_pixel(relativeX, relativeY, 1);
				}
				if (j > 0 && i < mapWidth && currentLvlMap[i+1][j-1]) { //top right corner
					ML_pixel(relativeX+6, relativeY, 1);
				}
				if (j < mapHeight && i > 0 && currentLvlMap[i-1][j+1]) { //bottom left corner
					ML_pixel(relativeX, relativeY+6, 1);
				}
				if (j < mapHeight && i < mapWidth && currentLvlMap[i+1][j+1]) { //bottom right corner
					ML_pixel(relativeX+6, relativeY+6, 1);
				}
			}	
			if (currentLvlMap[i][j] == 3) {
				posCharX = i;
				posCharY = j;
				currentLvlMap[i][j] = 1;
			}
		}
	}
	
	//Game playing loop
	
	do {
		GetKey(&key);
		if (key == KEY_CTRL_DOWN || key == KEY_CTRL_UP || key == KEY_CTRL_LEFT || key == KEY_CTRL_RIGHT) { //character has moved
			int xOffset = 0;
			int yOffset = 0;
			//moves the character appropriately
			if (key == KEY_CTRL_DOWN) yOffset++;
			else if (key == KEY_CTRL_UP) yOffset--;
			else if (key == KEY_CTRL_LEFT) xOffset--;
			else if (key == KEY_CTRL_RIGHT) xOffset++;
			
			//checks if the character is within the bounds of the map and if the position isn't a wall
			if (posCharY+yOffset < mapHeight && posCharY+yOffset >= 0 && posCharX+xOffset < mapWidth && posCharX+xOffset >= 0
					&& currentLvlMap[posCharX+xOffset][posCharY+yOffset] != 0) {
					
				//erase the current character sprite
				dispSprite(currentLvlMap[posCharX][posCharY], posXmap+7*posCharX, posYmap+7*posCharY);
				
				//checks if the new character position is a crate
				if (currentLvlMap[posCharX+xOffset][posCharY+yOffset] == 2 || currentLvlMap[posCharX+xOffset][posCharY+yOffset] == 5) {
					
					//checks if the crate can be pushed
					if (currentLvlMap[posCharX+2*xOffset][posCharY+2*yOffset] == 1 || currentLvlMap[posCharX+2*xOffset][posCharY+2*yOffset] == 4) {
						
						//replaces the old crate position by what is under it
						currentLvlMap[posCharX+xOffset][posCharY+yOffset]--;
						//puts the crate in its new position
						currentLvlMap[posCharX+2*xOffset][posCharY+2*yOffset]++;
						//moves the character
						posCharY += yOffset;
						posCharX += xOffset;
						//displays the crate
						dispSprite(currentLvlMap[posCharX+xOffset][posCharY+yOffset], posXmap+7*posCharX+7*xOffset, posYmap+7*posCharY+7*yOffset);
						
						//if the crate is on an emplacement, check if the player has won by checking if there are crates not on emplacement left
						if (currentLvlMap[posCharX+xOffset][posCharY+yOffset] == 5) {
							hasWon = 1;
							for (i = 0; i < mapWidth; i++) {
								for (j = 0; j < mapHeight; j++) {
									if (currentLvlMap[i][j] == 2)
										hasWon = 0;
								}
							}
						}
						dispSprite(key, posXmap+7*posCharX, posYmap+7*posCharY);
						
					} else {
						dispSprite(3, posXmap+7*posCharX, posYmap+7*posCharY);
					}
				} else { //new character position is floor/crate emplacement
					posCharY += yOffset;
					posCharX += xOffset;
					dispSprite(3, posXmap+7*posCharX, posYmap+7*posCharY);
				}
				
				//ML_pixel(1, 1, 1);
			}
		}
	} while (key != KEY_CTRL_EXIT && key != KEY_CTRL_F1 && key != KEY_CTRL_SHIFT && key != KEY_CTRL_EXE && !hasWon);
}

void dispSprite(int sprite, int x, int y) {
	DISPBOX dispBox;
	dispBox.left = x;
	dispBox.top = y;
	dispBox.right = x+6;
	dispBox.bottom = y+6;
	Bdisp_AreaClr_VRAM(&dispBox);
	
	switch(sprite) {
		case 0: //wall
			ML_horizontal_line(y, x, x+6, 1);
			ML_horizontal_line(y+6, x, x+6, 1);
			ML_vertical_line(x, y, y+6, 1);
			ML_vertical_line(x+6, y, y+6, 1);
			break;
		
		case 2: //crate
			/*ML_horizontal_line(y, x, x+6, 1);
			ML_horizontal_line(y+6, x, x+6, 1);
			ML_vertical_line(x, y, y+6, 1);
			ML_vertical_line(x+6, y, y+6, 1);
			ML_horizontal_line(y+2, x, x+6, 1);
			ML_horizontal_line(y+4, x, x+6, 1);*/
			
			ML_horizontal_line(y+1, x+1, x+5, 1);
			ML_horizontal_line(y+3, x+1, x+5, 1);
			ML_horizontal_line(y+5, x+1, x+5, 1);
			ML_vertical_line(x+1, y+1, y+5, 1);
			ML_vertical_line(x+5, y+1, y+5, 1);
			//ML_line(x, y, x+6, y+6, 1);
			//ML_line(x+6, y, x, y+6, 1);
			break;
		
		case 3: //character
			/*ML_pixel(x+3, y, 1);
			ML_pixel(x+2, y+1, 1);
			ML_pixel(x+4, y+1, 1);
			ML_horizontal_line(y+3, x+2, x+4, 1);
			ML_vertical_line(x+3, y+2, y+4, 1);
			ML_vertical_line(x+2, y+5, y+6, 1);
			ML_vertical_line(x+4, y+5, y+6, 1);*/
			ML_horizontal_line(y+1, x+2, x+4, 1);
			ML_horizontal_line(y+5, x+2, x+4, 1);
			ML_vertical_line(x+1, y+2, y+4, 1);
			ML_vertical_line(x+5, y+2, y+4, 1);
			ML_pixel(x+3, y+3, 1);
			break;
		
		case 4: //crate emplacement
			/*ML_horizontal_line(y+2, x+2, x+4, 1);
			ML_horizontal_line(y+4, x+2, x+4, 1);
			ML_pixel(x+2, y+3, 1);
			ML_pixel(x+4, y+3, 1);*/
			ML_line(x+1, y+1, x+6, y+6, 1);
			ML_line(x+1, y+5, x+6, y, 1);
			break;
		
		case 5: //crate on emplacement
			/*ML_horizontal_line(y, x, x+6, 1);
			ML_horizontal_line(y+6, x, x+6, 1);
			ML_vertical_line(x, y, y+6, 1);
			ML_vertical_line(x+6, y, y+6, 1);
			ML_horizontal_line(y+2, x+2, x+4, 1);
			ML_horizontal_line(y+4, x+2, x+4, 1);
			ML_pixel(x+2, y+3, 1);
			ML_pixel(x+4, y+3, 1);*/
			ML_horizontal_line(y+1, x+1, x+5, 1);
			ML_horizontal_line(y+5, x+1, x+5, 1);
			ML_vertical_line(x+1, y+1, y+5, 1);
			ML_vertical_line(x+5, y+1, y+5, 1);
			ML_line(x+1, y+1, x+5, y+5, 1);
			ML_line(x+1, y+5, x+5, y+1, 1);
			break;
		
		case KEY_CTRL_LEFT: //character facing left
			/*ML_horizontal_line(y, x, x+4, 1);
			ML_vertical_line(x+1, y, y+2, 1);
			ML_vertical_line(x+1, y+4, y+5, 1);
			ML_vertical_line(x+5, y+1, y+5, 1);
			ML_horizontal_line(y+6, x+2, x+4, 1);
			ML_pixel(x+2, y+3, 1);
			ML_pixel(x+3, y+3, 1);
			ML_pixel(x+3, y+4, 1);
			ML_pixel(x+4, y+2, 1);
			ML_pixel(x+4, y+5, 1);*/
			ML_horizontal_line(y+1, x, x+4, 1);
			ML_horizontal_line(y+5, x, x+4, 1);
			ML_vertical_line(x+1, y+2, y+4, 1);
			ML_vertical_line(x+5, y+2, y+4, 1);
			ML_pixel(x+3, y+3, 1);
			break;
			
		case KEY_CTRL_RIGHT:
			ML_horizontal_line(y+1, x+2, x+6, 1);
			ML_horizontal_line(y+5, x+2, x+6, 1);
			ML_vertical_line(x+1, y+2, y+4, 1);
			ML_vertical_line(x+5, y+2, y+4, 1);
			ML_pixel(x+3, y+3, 1);
			break;
		case KEY_CTRL_UP:
			ML_horizontal_line(y+1, x+2, x+4, 1);
			ML_horizontal_line(y+5, x+2, x+4, 1);
			ML_vertical_line(x+1, y, y+4, 1);
			ML_vertical_line(x+5, y, y+4, 1);
			ML_pixel(x+3, y+3, 1);
			break;
		case KEY_CTRL_DOWN:
			ML_horizontal_line(y+1, x+2, x+4, 1);
			ML_horizontal_line(y+5, x+2, x+4, 1);
			ML_vertical_line(x+1, y+2, y+6, 1);
			ML_vertical_line(x+5, y+2, y+6, 1);
			ML_pixel(x+3, y+3, 1);
			break;
	}
	
}


void sokobanLvl(int level) {
	mapHeight = 0;
	mapWidth = 0;
	if (level == 1) {
		char lvlMap[40] = {
			0, 0, 0, 0, 0, 0, 0, 0,
			0, 1, 1, 1, 0, 1, 1, 0,
			0, 1, 1, 1, 2, 3, 4, 0,
			0, 1, 1, 1, 0, 1, 1, 0
		}; mapWidth  = 8
		;  mapHeight = 5
		; playLvl(lvlMap);
	} else if (level == 2) {
		char lvlMap[42] = {
			0, 0, 0, 0 ,0 ,0, 0,
			0, 0, 0, 1, 1, 0, 0,
			0, 1, 2, 1, 4, 0, 0,
			0, 1, 2, 1, 1, 1, 0,
			0, 3, 0, 4, 1, 1, 0
		}; mapWidth  = 7
		;  mapHeight = 6
		; playLvl(lvlMap);
	} else if (level == 3) {
		char lvlMap[42] = {
			0, 0, 0, 0, 0, 0,
			0, 4, 4, 4, 1, 0,
			0, 1, 0, 2, 1, 0,
			0, 1, 2, 1, 1, 0,
			0, 1, 2, 1, 0, 0,
			0, 3, 1, 0, 0, 0,
		}; mapWidth  = 6
		;  mapHeight = 7
		; playLvl(lvlMap);
	} else if (level == 4) {
		char lvlMap[56] = {
			0,0,0,0,0,0,0,
			0,4,0,0,0,4,0,
			0,1,0,1,1,4,0,
			0,1,2,2,1,3,0,
			0,1,1,2,1,1,0,
			0,1,1,0,1,1,0,
			0,1,1,0,0,0,0
		}; mapWidth  = 7
		;  mapHeight = 8
		; playLvl(lvlMap);
	} else if (level == 5) {
		char lvlMap[56] = {
			0,0,0,0,0,0,0,0,
			0,0,1,3,1,0,0,0,
			0,0,1,4,1,1,1,0,
			0,4,1,2,4,2,1,0,
			0,0,2,0,1,0,0,0,
			0,0,1,1,1,0,0,0,
		}; mapWidth  = 8
		;  mapHeight = 7
		; playLvl(lvlMap);
	} else if (level == 6) {
		char lvlMap[48] = {
			0,0,0,0,0,0,0,0,
			0,0,1,1,0,0,0,0,
			0,1,1,1,1,1,0,0,
			0,1,1,0,2,2,3,0,
			0,1,1,4,1,5,4,0,
		}; mapWidth  = 8
		;  mapHeight = 6
		; playLvl(lvlMap);
	} else if (level == 7) {
		char lvlMap[64] = {
			0,0,0,0,0,0,0,0,
			0,1,1,1,1,1,1,0,
			0,1,0,1,0,0,5,0,
			0,1,0,3,1,2,1,0,
			0,4,2,1,4,1,1,0,
			0,0,0,0,0,1,1,0,
			0,0,0,0,0,1,1,0,
		}; mapWidth  = 8
		;  mapHeight = 8
		; playLvl(lvlMap);
	} else if (level == 8
	){	char lvlMap[64] = {
			0,0,0,0,0,0,0,0,
			0,1,1,1,0,0,0,0,
			0,1,2,2,1,1,1,0,
			0,1,4,0,4,1,1,0,
			0,1,1,0,0,1,0,0,
			0,1,1,0,0,2,0,0,
			0,1,3,1,1,4,0,0,
		}; mapWidth  = 8
		;  mapHeight = 8
		; playLvl(lvlMap);
	} else if (level ==9
	){	char lvlMap[64] = {
			0,0,0,0,0,0,0,0,
			0,0,1,1,1,4,1,0,
			0,1,2,1,1,2,3,0,
			0,4,2,4,0,0,0,0,
			0,1,1,0,0,0,0,0,
			0,1,1,0,0,0,0,0,
			0,1,1,0,0,0,0,0,
		}; mapWidth  = 8
		;  mapHeight = 8
		; playLvl(lvlMap);
	} else if (level ==10
	){	char lvlMap[56] = {
			0,0,0,0,0,0,0,0,
			0,0,0,0,1,4,1,0,
			0,1,5,3,1,4,1,0,
			0,1,2,1,0,1,1,0,
			0,1,0,1,1,2,1,0,
			0,1,1,1,0,0,0,0
		}; mapWidth  = 8
		;  mapHeight = 7
		; playLvl(lvlMap);
	} else if (level ==11
	){	char lvlMap[48] = {
			0,0,0,0,0,0,0,0,
			0,0,0,1,1,0,0,0,
			0,1,4,4,1,2,4,0,
			0,1,1,2,2,1,3,0,
			0,0,0,0,1,1,1,0,
		}; mapWidth  = 8
		;  mapHeight = 6
		; playLvl(lvlMap);
	} else if (level ==12
	){	char lvlMap[64] = {
			0,0,0,0,0,0,0,0,
			0,0,0,0,1,3,1,0,
			0,0,0,0,1,1,1,0,
			0,0,1,2,1,2,0,0,
			0,0,1,2,1,1,0,0,
			0,4,1,1,0,1,0,0,
			0,4,4,1,1,1,0,0,
		}; mapWidth  = 8
		;  mapHeight = 8
		; playLvl(lvlMap);
	} else if (level ==13
	){	char lvlMap[100] = {
			0,0,0,0,0,0,0,0,0,0,
			0,0,0,0,0,0,0,4,4,0,
			0,0,0,0,0,1,1,4,4,0,
			0,0,0,0,0,1,1,2,1,0,
			0,0,0,0,0,0,1,0,0,0,
			0,3,1,1,1,1,1,0,0,0,
			0,0,1,0,1,2,1,2,1,0,
			0,0,1,2,1,0,1,0,1,0,
			0,0,1,1,1,0,1,1,1,0,
		}; mapWidth  = 10
		;  mapHeight = 10
		; playLvl(lvlMap);
	} else if (level ==14
	){	char lvlMap[63] = {
			0,0,0,0,0,0,0,0,0,
			0,4,4,4,4,0,0,0,0,
			0,3,1,2,2,2,1,4,0,
			0,0,1,1,2,1,1,1,0,
			0,0,0,0,0,2,0,1,0,
			0,0,0,0,0,1,1,1,0,
		}; mapWidth  = 9
		;  mapHeight = 7
		; playLvl(lvlMap);
	} else if (level ==15
	){	char lvlMap[56] = {
			0,0,0,0,0,0,0,0,
			0,1,1,1,1,1,0,0,
			0,1,4,5,2,2,1,0,
			0,1,5,1,0,3,1,0,
			0,1,4,5,1,1,0,0,
			0,1,1,1,1,1,0,0,
		}; mapWidth  = 8
		;  mapHeight = 7
		; playLvl(lvlMap);
	} else if (level ==16
	){	char lvlMap[60] = {
			0,0,0,0,0,0,0,0,0,0,
			0,0,1,1,2,3,4,4,4,0,
			0,1,1,2,2,0,0,0,0,0,
			0,1,1,1,1,0,0,0,0,0,
			0,0,1,1,1,0,0,0,0,0,
		}; mapWidth  = 10
		;  mapHeight = 6
		; playLvl(lvlMap);
	} else if (level ==17
	){	char lvlMap[48] = {
			0,0,0,0,0,0,
			0,1,1,3,1,0,
			0,1,2,1,1,0,
			0,0,1,0,2,0,
			0,1,2,2,1,0,
			0,1,1,2,4,0,
			0,4,4,4,4,0,
		}; mapWidth  = 6
		;  mapHeight = 8
		; playLvl(lvlMap);
	} else if (level ==18
	){	char lvlMap[88] = {
			0,0,0,0,0,0,0,0,0,0,0,
			0,1,1,1,5,1,3,0,0,0,0,
			0,1,2,4,1,5,1,0,0,0,0,
			0,0,0,1,5,4,1,1,0,0,0,
			0,0,1,5,4,5,2,2,1,1,0,
			0,0,1,1,1,1,1,1,1,1,0,
			0,0,0,0,0,0,0,0,1,1,0,
		}; mapWidth  = 11
		;  mapHeight = 8
		; playLvl(lvlMap);
	} else if (level ==19
	){	char lvlMap[56] = {
			0,0,0,0,0,0,0,
			0,0,0,0,1,3,0,
			0,1,1,5,2,1,0,
			0,1,1,1,1,1,0,
			0,0,1,4,0,0,0,
			0,0,2,1,0,0,0,
			0,0,1,4,0,0,0,
		}; mapWidth  = 7
		;  mapHeight = 8
		; playLvl(lvlMap);
	} if (level ==20
	){	char lvlMap[56] = {
			0,0,0,0,0,0,0,0,
			0,0,1,1,0,0,0,0,
			0,4,4,2,1,1,4,0,
			0,1,0,2,1,2,1,0,
			0,3,1,1,0,1,1,0,
			0,0,0,0,0,1,1,0,
		}; mapWidth  = 8
		;  mapHeight = 7
		; playLvl(lvlMap);
	} else if (level ==21
	){	char lvlMap[64] = {
			0,0,0,0,0,0,0,0,
			0,1,1,4,0,0,0,0,
			0,1,2,4,4,1,0,0,
			0,1,1,0,0,2,0,0,
			0,0,1,1,0,1,1,0,
			0,0,2,1,1,1,3,0,
			0,0,1,1,0,0,0,0,
		}; mapWidth  = 8
		;  mapHeight = 8
		; playLvl(lvlMap);
	} else if (level ==22
	){	char lvlMap[56] = {
			0,0,0,0,0,0,0,0,
			0,1,1,1,0,0,0,0,
			0,1,0,1,5,3,0,0,
			0,1,1,5,1,1,1,0,
			0,0,0,2,1,1,1,0,
			0,0,0,1,1,1,4,0,
		}; mapWidth  = 8
		;  mapHeight = 7
		; playLvl(lvlMap);
	} else if (level ==23
	){	char lvlMap[56] = {
			0,0,0,0,0,0,0,
			0,1,1,1,0,0,0,
			0,1,1,2,1,1,0,
			0,0,2,2,1,4,0,
			0,0,3,1,4,1,0,
			0,0,0,1,0,1,0,
			0,0,0,1,1,4,0,
		}; mapWidth  = 7
		;  mapHeight = 8
		; playLvl(lvlMap);
	} else if (level ==24
	){	char lvlMap[48] = {
			0,0,0,0,0,0,0,0,
			0,1,4,1,1,0,0,0,
			0,1,4,0,1,0,0,0,
			0,1,3,2,2,1,1,0,
			0,1,2,4,1,1,1,0,
		}; mapWidth  = 8
		;  mapHeight = 6
		; playLvl(lvlMap);
	} else if (level ==25
	){	char lvlMap[64] = {
			0,0,0,0,0,0,0,0,
			0,0,0,0,1,1,0,0,
			0,0,0,0,1,2,0,0,
			0,1,3,2,4,1,1,0,
			0,1,0,0,1,1,1,0,
			0,1,1,1,0,0,1,0,
			0,1,1,1,5,1,4,0,
		}; mapWidth  = 8
		;  mapHeight = 8
		; playLvl(lvlMap);
	} else if (level ==26
	){	char lvlMap[56] = {
			0,0,0,0,0,0,0,0,
			0,1,1,1,1,1,1,0,
			0,1,0,2,1,1,1,0,
			0,1,2,1,3,0,4,0,
			0,0,2,0,4,1,1,0,
			0,0,1,1,1,1,4,0,
		}; mapWidth  = 8
		;  mapHeight = 7
		; playLvl(lvlMap);
	} else if (level ==27
	){	char lvlMap[100] = {
			0,0,0,0,0,0,0,0,0,0,
			0,0,1,1,3,0,0,4,4,0,
			0,1,1,2,1,0,0,4,4,0,
			0,1,2,0,0,0,0,4,5,0,
			0,1,1,1,1,1,0,4,4,0,
			0,1,2,0,2,1,0,2,1,0,
			0,1,1,2,1,0,0,1,1,0,
			0,0,0,1,1,1,1,1,2,0,
			0,0,0,0,0,0,1,1,1,0,
		}; mapWidth  = 10
		;  mapHeight = 10
		; playLvl(lvlMap);
	} else if (level ==28
	){	char lvlMap[64] = {
			0,0,0,0,0,0,0,0,
			0,0,0,1,2,4,4,0,
			0,0,0,1,1,5,4,0,
			0,1,1,2,1,5,4,0,
			0,1,2,2,2,0,4,0,
			0,1,1,0,1,0,0,0,
			0,3,1,1,1,0,0,0,
		}; mapWidth  = 8
		;  mapHeight = 8
		; playLvl(lvlMap);
	} else if (level ==29
	){	char lvlMap[49] = {
			0,0,0,0,0,0,0,
			0,0,1,1,4,1,0,
			0,1,5,1,0,1,0,
			0,1,4,2,1,1,0,
			0,1,1,0,2,0,0,
			0,0,1,3,1,0,0,
		}; mapWidth  = 7
		;  mapHeight = 7
		; playLvl(lvlMap);
	} else if (level ==30
	){	char lvlMap[56] = {
			0,0,0,0,0,0,0,
			0,0,0,1,1,4,0,
			0,1,2,1,0,1,0,
			0,1,5,2,1,1,0,
			0,1,4,0,3,1,0,
			0,1,1,1,1,0,0,
			0,1,1,1,0,0,0,
		}; mapWidth  = 7
		;  mapHeight = 8
		; playLvl(lvlMap);
	} else if (level ==31
	){	char lvlMap[64] = {
			0,0,0,0,0,0,0,0,
			0,1,1,1,3,0,0,0,
			0,1,2,0,1,0,0,0,
			0,1,5,1,2,1,1,0,
			0,1,1,1,0,0,1,0,
			0,0,4,1,1,4,1,0,
			0,0,0,1,1,1,0,0,
		}; mapWidth  = 8
		;  mapHeight = 8
		; playLvl(lvlMap);
	} else if (level ==32
	){	char lvlMap[49] = {
			0,0,0,0,0,0,0,
			0,1,1,1,3,0,0,
			0,1,1,0,1,1,0,
			0,4,1,1,2,1,0,
			0,1,2,2,0,4,0,
			0,0,0,1,1,4,0,
		}; mapWidth  = 7
		;  mapHeight = 7
		; playLvl(lvlMap);
	} else if (level ==33
	){	char lvlMap[64] = {
			0,0,0,0,0,0,0,0,
			0,1,3,4,0,1,1,0,
			0,1,4,2,1,4,1,0,
			0,1,1,0,2,1,1,0,
			0,1,1,2,1,1,0,0,
			0,0,0,1,1,0,0,0,
			0,0,0,1,1,0,0,0,
		}; mapWidth  = 8
		;  mapHeight = 8
		; playLvl(lvlMap);
	} else if (level ==34
	){	char lvlMap[56] = {
			0,0,0,0,0,0,0,0,
			0,0,0,0,0,3,1,0,
			0,0,0,0,0,1,4,0,
			0,1,2,1,2,1,2,0,
			0,1,1,1,4,1,1,0,
			0,0,0,1,4,1,1,0,
		}; mapWidth  = 8
		;  mapHeight = 7
		; playLvl(lvlMap);
	} else if (level ==35
	){	char lvlMap[64] = {
			0,0,0,0,0,0,0,0,
			0,1,1,1,0,1,1,0,
			0,1,0,4,2,1,2,0,
			0,1,1,1,2,1,1,0,
			0,0,0,0,0,4,1,0,
			0,0,0,1,1,1,3,0,
			0,0,0,1,1,1,4,0,
		}; mapWidth  = 8
		;  mapHeight = 8
		; playLvl(lvlMap);
	} else if (level ==36
	){	char lvlMap[64] = {
			0,0,0,0,0,0,0,0,
			0,0,0,0,3,1,0,0,
			0,0,0,1,1,4,4,0,
			0,0,1,2,0,2,0,0,
			0,1,1,1,2,4,1,0,
			0,1,1,0,1,1,1,0,
			0,1,1,1,1,0,0,0,
		}; mapWidth  = 8
		;  mapHeight = 8
		; playLvl(lvlMap);
	} else if (level ==37
	){	char lvlMap[99] = {
			0,0,0,0,0,0,0,0,0,0,0,
			0,1,4,0,0,0,0,1,1,1,0,
			0,1,4,0,1,1,2,1,0,1,0,
			0,1,4,0,2,1,1,2,0,1,0,
			0,4,4,4,2,1,1,1,1,1,0,
			0,0,1,2,2,0,0,2,1,0,0,
			0,0,4,0,1,2,1,1,1,0,0,
			0,0,4,0,3,1,0,1,1,0,0,
		}; mapWidth  = 11
		;  mapHeight = 9
		; playLvl(lvlMap);
	} else if (level ==38
	){	char lvlMap[56] = {
			0,0,0,0,0,0,0,0,
			0,0,1,1,1,1,1,0,
			0,0,1,4,2,5,1,0,
			0,1,1,5,3,5,1,0,
			0,1,1,5,2,4,1,0,
			0,0,1,1,1,1,0,0,
		}; mapWidth  = 8
		;  mapHeight = 7
		; playLvl(lvlMap);
	} else if (level ==39
	){	char lvlMap[49] = {
			0,0,0,0,0,0,0,
			0,4,1,4,0,0,0,
			0,4,0,2,2,1,0,
			0,1,1,1,3,1,0,
			0,1,2,0,1,1,0,
			0,0,1,1,1,0,0,
		}; mapWidth  = 7
		;  mapHeight = 7
		; playLvl(lvlMap);
	} if (level ==40
	){	char lvlMap[56] = {
			0,0,0,0,0,0,0,0,
			0,4,1,1,1,4,1,0,
			0,1,0,1,0,1,1,0,
			0,3,2,1,1,2,4,0,
			0,0,0,0,0,1,2,0,
			0,0,0,0,0,1,1,0,
		}; mapWidth  = 8
		;  mapHeight = 7
		; playLvl(lvlMap);
	} else if (level ==41
	){	char lvlMap[64] = {
			0,0,0,0,0,0,0,0,
			0,0,0,0,0,1,1,0,
			0,0,0,0,0,2,4,0,
			0,0,0,1,1,4,1,0,
			0,0,0,1,1,0,4,0,
			0,1,2,1,1,2,1,0,
			0,1,1,1,0,3,1,0,
		}; mapWidth  = 8
		;  mapHeight = 8
		; playLvl(lvlMap);
	} else if (level ==42
	){	char lvlMap[64] = {
			0,0,0,0,0,0,0,0,
			0,0,0,1,4,1,1,0,
			0,1,2,3,0,4,1,0,
			0,1,1,2,0,1,0,0,
			0,1,1,5,1,1,0,0,
			0,0,1,1,0,1,0,0,
			0,0,0,1,1,1,0,0,
		}; mapWidth  = 8
		;  mapHeight = 8
		; playLvl(lvlMap);
	} else if (level ==43
	){	char lvlMap[64] = {
			0,0,0,0,0,0,0,0,
			0,1,1,1,3,0,0,0,
			0,1,2,2,0,0,0,0,
			0,1,2,1,4,1,1,0,
			0,0,1,0,4,0,1,0,
			0,4,1,1,1,0,1,0,
			0,1,1,1,1,1,1,0,
		}; mapWidth  = 8
		;  mapHeight = 8
		; playLvl(lvlMap);
	} else if (level ==44
	){	char lvlMap[56] = {
			0,0,0,0,0,0,0,0,
			0,0,0,0,4,1,3,0,
			0,1,1,4,2,1,1,0,
			0,1,0,1,1,0,0,0,
			0,1,2,1,2,1,4,0,
			0,0,0,0,1,1,1,0,
		}; mapWidth  = 8
		;  mapHeight = 7
		; playLvl(lvlMap);
	} else if (level ==45
	){	char lvlMap[64] = {
			0,0,0,0,0,0,0,0,
			0,4,1,0,0,0,0,0,
			0,1,2,0,0,0,0,0,
			0,1,1,0,0,0,0,0,
			0,1,4,2,1,3,1,0,
			0,1,4,2,1,0,1,0,
			0,0,0,1,1,1,1,0,
		}; mapWidth  = 8
		;  mapHeight = 8
		; playLvl(lvlMap);
	} else if (level ==46
	){	char lvlMap[56] = {
			0,0,0,0,0,0,0,0,
			0,3,1,1,1,1,1,0,
			0,1,5,1,5,1,1,0,
			0,5,2,5,5,5,4,0,
			0,1,5,1,1,1,1,0,
			0,1,1,1,1,1,0,0,
		}; mapWidth  = 8
		;  mapHeight = 7
		; playLvl(lvlMap);
	} else if (level ==47
	){	char lvlMap[99] = {
			0,0,0,0,0,0,0,0,0,0,0,
			0,0,1,1,1,1,0,0,0,0,0,
			0,0,1,1,2,2,0,0,0,0,0,
			0,1,1,0,2,1,1,0,0,0,0,
			0,1,2,1,1,0,4,0,0,0,0,
			0,1,1,2,0,0,4,4,0,0,0,
			0,0,1,1,1,4,4,4,2,1,0,
			0,0,0,0,0,3,1,1,1,1,0,
		}; mapWidth  = 11
		;  mapHeight = 9
		; playLvl(lvlMap);
	} else if (level ==48
	){	char lvlMap[88] = {
			0,0,0,0,0,0,0,0,0,0,0,
			0,1,1,1,4,2,3,0,0,0,0,
			0,1,2,4,1,5,1,0,0,0,0,
			0,0,1,0,5,5,1,1,0,0,0,
			0,0,1,5,4,5,1,1,2,1,0,
			0,0,1,1,1,1,1,1,1,1,0,
			0,0,0,0,0,0,0,0,1,1,0,
		}; mapWidth  = 11
		;  mapHeight = 8
		; playLvl(lvlMap);
	} else if (level ==49
	){	char lvlMap[56] = {
			0,0,0,0,0,0,0,0,
			0,4,1,1,3,4,0,0,
			0,1,1,2,0,1,0,0,
			0,1,0,1,2,4,1,0,
			0,1,1,1,2,0,1,0,
			0,0,0,0,1,1,1,0,
		}; mapWidth  = 8
		;  mapHeight = 7
		; playLvl(lvlMap);
	} else if (level ==50
	){	char lvlMap[64] = {
			0,0,0,0,0,0,0,0,
			0,0,1,1,4,3,0,0,
			0,0,1,1,1,2,4,0,
			0,0,0,0,5,0,1,0,
			0,0,1,1,1,1,1,0,
			0,1,1,2,1,1,0,0,
			0,1,1,1,0,0,0,0,
		}; mapWidth  = 8
		;  mapHeight = 8
		; playLvl(lvlMap);
	} else if (level ==51
	){	char lvlMap[64] = {
			0,0,0,0,0,0,0,0,
			0,0,3,4,1,1,0,0,
			0,1,2,2,5,1,0,0,
			0,1,1,0,1,1,0,0,
			0,1,1,0,1,1,4,0,
			0,0,0,0,1,0,1,0,
			0,0,0,0,1,1,1,0,
		}; mapWidth  = 8
		;  mapHeight = 8
		; playLvl(lvlMap);
	} else if (level ==52
	){	char lvlMap[56] = {
			0,0,0,0,0,0,0,0,
			0,0,3,1,1,1,1,0,
			0,4,1,0,1,1,1,0,
			0,1,2,2,2,4,0,0,
			0,1,4,0,1,1,0,0,
			0,1,1,0,0,0,0,0,
		}; mapWidth  = 8
		;  mapHeight = 7
		; playLvl(lvlMap);
	} else if (level ==53
	){	char lvlMap[120] = {
			0,0,0,0,0,0,0,0,0,0,0,0,
			0,1,4,4,5,1,1,1,2,1,0,0,
			0,1,4,5,4,1,2,1,1,1,1,0,
			0,0,4,4,0,0,0,0,1,1,1,0,
			0,0,0,0,0,4,0,0,1,0,0,0,
			0,0,3,1,0,1,2,1,1,0,0,0,
			0,0,1,2,0,1,0,2,1,0,0,0,
			0,0,1,1,2,1,2,1,0,0,0,0,
			0,0,0,1,1,1,1,1,0,0,0,0,
		}; mapWidth  = 12
		;  mapHeight = 10
		; playLvl(lvlMap);
	} else if (level ==54
	){	char lvlMap[121] = {
			0,0,0,0,0,0,0,0,0,0,0,
			0,0,0,1,1,0,0,0,0,0,0,
			0,1,1,1,1,0,3,1,1,1,0,
			0,1,1,0,1,2,1,2,2,1,0,
			0,1,1,1,2,1,1,1,1,0,0,
			0,0,2,0,0,1,0,0,0,0,0,
			0,0,1,1,0,2,1,0,0,0,0,
			0,0,0,4,4,4,4,0,0,0,0,
			0,0,0,0,0,4,1,0,0,0,0,
			0,0,0,0,0,4,1,0,0,0,0,
		}; mapWidth  = 11
		;  mapHeight = 11
		; playLvl(lvlMap);
	} else if (level ==55
	){	char lvlMap[56] = {
			0,0,0,0,0,0,0,0,
			0,1,1,1,0,0,0,0,
			0,1,0,1,1,1,1,0,
			0,1,1,2,5,5,4,0,
			0,1,0,1,0,1,1,0,
			0,3,1,1,0,0,0,0,
		}; mapWidth  = 8
		;  mapHeight = 7
		; playLvl(lvlMap);
	} else if (level ==56
	){	char lvlMap[64] = {
			0,0,0,0,0,0,0,0,
			0,0,0,0,1,3,0,0,
			0,0,0,0,1,1,1,0,
			0,4,1,0,2,2,1,0,
			0,1,1,1,1,1,0,0,
			0,4,1,1,2,0,0,0,
			0,0,4,1,1,0,0,0,
		}; mapWidth  = 8
		;  mapHeight = 8
		; playLvl(lvlMap);
	} else if (level ==57
	){	char lvlMap[48] = {
			0,0,0,0,0,0,0,0,
			0,1,4,4,0,0,0,0,
			0,1,2,1,1,1,1,0,
			0,1,1,0,2,0,1,0,
			0,1,3,1,4,2,1,0,
		}; mapWidth  = 8
		;  mapHeight = 6
		; playLvl(lvlMap);
	} else if (level ==58
	){	char lvlMap[64] = {
			0,0,0,0,0,0,0,0,
			0,1,1,0,0,0,0,0,
			0,1,1,0,0,0,0,0,
			0,1,4,5,1,1,1,0,
			0,0,2,1,1,1,1,0,
			0,0,1,0,2,0,0,0,
			0,0,4,1,3,0,0,0,
		}; mapWidth  = 8
		;  mapHeight = 8
		; playLvl(lvlMap);
	} else if (level ==59
	){	char lvlMap[64] = {
			0,0,0,0,0,0,0,0,
			0,0,0,1,1,0,0,0,
			0,0,0,1,1,0,0,0,
			0,0,0,1,4,4,1,0,
			0,1,1,2,0,1,1,0,
			0,1,1,4,2,2,1,0,
			0,0,0,0,1,3,1,0,
		}; mapWidth  = 8
		;  mapHeight = 8
		; playLvl(lvlMap);
	} if (level ==60
	){	char lvlMap[49] = {
			0,0,0,0,0,0,0,
			0,1,1,1,1,1,0,
			0,4,0,0,1,4,0,
			0,5,1,1,2,3,0,
			0,1,1,0,2,1,0,
			0,1,1,0,1,1,0,
		}; mapWidth  = 7
		;  mapHeight = 7
		; playLvl(lvlMap);
	} else if (level ==61
	){	char lvlMap[80] = {
			0,0,0,0,0,0,0,0,0,0,
			0,1,1,3,0,0,1,1,0,0,
			0,1,2,2,1,1,4,4,0,0,
			0,1,1,2,2,0,4,4,1,0,
			0,1,2,2,1,0,4,4,1,0,
			0,1,1,0,1,0,0,0,0,0,
			0,0,1,1,1,0,0,0,0,0,
		}; mapWidth  = 10
		;  mapHeight = 8
		; playLvl(lvlMap);
	} else if (level ==62
	){	char lvlMap[80] = {
			0,0,0,0,0,0,0,0,0,0,
			0,0,0,1,1,1,0,0,0,0,
			0,0,1,2,1,1,1,2,1,0,
			0,0,4,1,2,2,0,2,3,0,
			0,0,4,0,0,1,1,2,1,0,
			0,1,5,4,0,1,1,1,0,0,
			0,1,4,4,4,1,0,0,0,0,
		}; mapWidth  = 10
		;  mapHeight = 8
		; playLvl(lvlMap);
	} else if (level ==63
	){	char lvlMap[64] = {
			0,0,0,0,0,0,0,0,
			0,4,4,4,0,0,0,0,
			0,4,2,2,1,0,0,0,
			0,3,5,1,2,1,4,0,
			0,0,0,1,2,1,1,0,
			0,0,0,1,1,2,1,0,
			0,0,0,0,0,1,1,0,
		}; mapWidth  = 8
		;  mapHeight = 8
		; playLvl(lvlMap);
	} else if (level ==64
	){	char lvlMap[56] = {
			0,0,0,0,0,0,0,0,
			0,3,1,1,0,0,0,0,
			0,1,0,1,0,0,0,0,
			0,1,4,2,2,1,1,0,
			0,1,4,4,2,0,1,0,
			0,0,0,1,1,1,1,0,
		}; mapWidth  = 8
		;  mapHeight = 7
		; playLvl(lvlMap);
	} else if (level ==65
	){	char lvlMap[56] = {
			0,0,0,0,0,0,0,
			0,4,1,1,0,0,0,
			0,1,0,1,1,1,0,
			0,1,4,1,0,1,0,
			0,1,2,5,2,1,0,
			0,0,3,1,0,0,0,
			0,0,1,1,0,0,0,
		}; mapWidth  = 7
		;  mapHeight = 8
		; playLvl(lvlMap);
	} else if (level ==66
	){	char lvlMap[56] = {
			0,0,0,0,0,0,0,
			0,1,4,1,1,0,0,
			0,1,1,0,3,0,0,
			0,1,1,2,1,0,0,
			0,0,2,0,1,1,0,
			0,1,1,1,0,1,0,
			0,4,1,5,1,1,0,
		}; mapWidth  = 7
		;  mapHeight = 8
		; playLvl(lvlMap);
	} else if (level ==67
	){	char lvlMap[64] = {
			0,0,0,0,0,0,0,0,
			0,1,1,4,1,0,0,0,
			0,1,1,1,1,0,0,0,
			0,1,0,2,2,4,1,0,
			0,4,1,1,0,0,1,0,
			0,3,2,1,0,0,1,0,
			0,0,0,1,1,1,1,0,
		}; mapWidth  = 8
		;  mapHeight = 8
		; playLvl(lvlMap);
	} else if (level ==68
	){	char lvlMap[132] = {
			0,0,0,0,0,0,0,0,0,0,0,0,
			0,0,0,0,0,0,0,1,1,0,0,0,
			0,0,0,0,0,0,0,1,1,0,0,0,
			0,0,1,1,1,0,0,1,1,1,1,0,
			0,3,2,1,1,2,1,2,0,1,1,0,
			0,1,1,0,0,2,2,1,1,2,1,0,
			0,0,1,2,1,1,0,0,4,2,1,0,
			0,0,0,1,1,1,0,4,4,5,0,0,
			0,0,0,0,0,0,0,4,4,4,0,0,
			0,0,0,0,0,0,0,4,4,0,0,0,
		}; mapWidth  = 12
		;  mapHeight = 11
		; playLvl(lvlMap);
	} else if (level ==69
	){	char lvlMap[72] = {
			0,0,0,0,0,0,0,0,0,
			0,0,0,4,4,4,1,1,0,
			0,0,1,1,0,2,0,1,0,
			0,0,1,1,1,1,0,1,0,
			0,0,1,0,0,2,0,1,0,
			0,1,1,1,1,2,1,1,0,
			0,3,1,1,0,1,1,0,0,
		}; mapWidth  = 9
		;  mapHeight = 8
		; playLvl(lvlMap);
	} else if (level ==70
	){	char lvlMap[72] = {
			0,0,0,0,0,0,0,0,0,
			0,4,4,4,0,1,1,0,0,
			0,1,4,5,1,1,1,0,0,
			0,0,3,2,2,2,1,1,0,
			0,0,0,0,1,2,1,1,0,
			0,0,0,0,1,1,1,0,0,
			0,0,0,0,0,1,1,0,0,
		}; mapWidth  = 9
		;  mapHeight = 8
		; playLvl(lvlMap);
	} else if (level ==71
	){	char lvlMap[56] = {
			0,0,0,0,0,0,0,0,
			0,0,0,1,3,0,0,0,
			0,0,0,1,1,0,0,0,
			0,1,1,2,5,1,1,0,
			0,1,1,5,4,1,1,0,
			0,0,0,1,1,1,0,0,
		}; mapWidth  = 8
		;  mapHeight = 7
		; playLvl(lvlMap);
	} else if (level ==72
	){	char lvlMap[49] = {
			0,0,0,0,0,0,0,
			0,1,1,4,3,1,0,
			0,1,0,4,0,1,0,
			0,1,1,1,2,1,0,
			0,4,2,2,1,0,0,
			0,1,1,0,0,0,0,
		}; mapWidth  = 7
		;  mapHeight = 7
		; playLvl(lvlMap);
	} else if (level ==73
	){	char lvlMap[49] = {
			0,0,0,0,0,0,0,
			0,4,1,1,0,0,0,
			0,1,0,1,0,0,0,
			0,1,5,2,1,1,0,
			0,1,1,2,4,1,0,
			0,1,1,3,0,0,0,
		}; mapWidth  = 7
		;  mapHeight = 7
		; playLvl(lvlMap);
	} if (level ==74
	){	char lvlMap[63] = {
			0,0,0,0,0,0,0,0,0,
			0,0,0,0,1,1,1,0,0,
			0,0,0,0,1,0,1,0,0,
			0,1,1,2,4,2,1,1,0,
			0,1,1,4,2,4,0,1,0,
			0,0,0,0,3,1,1,1,0,
		}; mapWidth  = 9
		;  mapHeight = 7
		; playLvl(lvlMap);
	} else if (level ==75
	){	char lvlMap[132] = {
			0,0,0,0,0,0,0,0,0,0,0,0,
			0,0,0,1,1,1,1,0,0,0,0,0,
			0,0,0,2,1,2,1,0,0,0,0,0,
			0,1,1,1,2,1,1,1,2,1,0,0,
			0,1,2,1,0,1,2,1,4,5,1,0,
			0,0,0,1,1,0,1,1,0,4,1,0,
			0,0,0,1,1,2,1,0,4,4,3,0,
			0,0,0,1,1,2,0,0,4,4,4,0,
			0,0,0,0,1,2,1,0,0,0,0,0,
			0,0,0,0,1,1,4,4,0,0,0,0,
		}; mapWidth  = 12
		;  mapHeight = 11
		; playLvl(lvlMap);
	} else if (level ==76
	){	char lvlMap[72] = {
			0,0,0,0,0,0,0,0,0,
			0,0,0,4,4,4,1,4,0,
			0,0,1,2,0,4,0,1,0,
			0,0,2,3,1,1,2,1,0,
			0,0,1,0,0,2,0,1,0,
			0,1,2,1,1,1,1,1,0,
			0,1,1,1,0,1,1,0,0,
		}; mapWidth  = 9
		;  mapHeight = 8
		; playLvl(lvlMap);
	} else if (level ==77
	){	char lvlMap[56] = {
			0,0,0,0,0,0,0,
			0,0,1,1,1,0,0,
			0,1,2,0,1,0,0,
			0,1,4,1,3,0,0,
			0,1,5,1,1,1,0,
			0,0,1,0,2,1,0,
			0,0,4,1,1,0,0,
		}; mapWidth  = 7
		;  mapHeight = 8
		; playLvl(lvlMap);
	} else if (level ==78
	){	char lvlMap[64] = {
			0,0,0,0,0,0,0,0,
			0,0,3,1,0,0,0,0,
			0,0,1,1,0,0,0,0,
			0,0,4,1,0,0,0,0,
			0,1,2,2,4,1,4,0,
			0,1,1,2,1,0,0,0,
			0,0,0,1,1,0,0,0,
		}; mapWidth  = 8
		;  mapHeight = 8
		; playLvl(lvlMap);
	} else if (level ==79
	){	char lvlMap[49] = {
			0,0,0,0,0,0,0,
			0,0,0,1,1,1,0,
			0,0,0,1,0,4,0,
			0,0,0,1,1,4,0,
			0,3,1,2,2,1,0,
			0,1,1,4,2,1,0,
		}; mapWidth  = 7
		;  mapHeight = 7
		; playLvl(lvlMap);
	} else if (level ==80
	){	char lvlMap[48] = {
			0,0,0,0,0,0,0,0,
			0,0,0,4,1,0,0,0,
			0,1,4,1,1,0,0,0,
			0,1,1,1,2,2,1,0,
			0,0,1,4,1,2,3,0,
		}; mapWidth  = 8
		;  mapHeight = 6
		; playLvl(lvlMap);
	} else if (level ==81
	){	char lvlMap[64] = {
			0,0,0,0,0,0,0,0,
			0,0,3,1,1,1,0,0,
			0,0,0,2,1,1,1,0,
			0,0,0,1,4,1,1,0,
			0,1,2,1,0,2,0,0,
			0,1,4,1,1,4,0,0,
			0,0,0,0,1,1,0,0,
		}; mapWidth  = 8
		;  mapHeight = 8
		; playLvl(lvlMap);
	} else if (level ==82
	){	char lvlMap[56] = {
			0,0,0,0,0,0,0,0,
			0,1,1,4,0,1,3,0,
			0,1,0,1,2,1,1,0,
			0,1,2,4,0,2,1,0,
			0,0,1,4,1,1,1,0,
			0,0,1,1,0,0,0,0,
		}; mapWidth  = 8
		;  mapHeight = 7
		; playLvl(lvlMap);
	} else if (level ==83
	){	char lvlMap[64] = {
			0,0,0,0,0,0,0,0,
			0,4,4,4,4,0,0,0,
			0,4,2,5,2,0,0,0,
			0,3,5,1,2,1,1,0,
			0,0,0,1,2,1,1,0,
			0,0,0,1,1,2,1,0,
			0,0,0,0,1,1,1,0,
		}; mapWidth  = 8
		;  mapHeight = 8
		; playLvl(lvlMap);
	} else if (level ==84
	){	char lvlMap[110] = {
			0,0,0,0,0,0,0,0,0,0,0,
			0,4,4,0,0,0,0,0,0,0,0,
			0,4,4,4,3,0,0,0,0,0,0,
			0,4,4,2,1,1,1,1,1,1,0,
			0,0,0,2,1,0,0,0,1,1,0,
			0,0,0,1,2,0,1,2,1,0,0,
			0,1,1,1,1,2,1,1,1,0,0,
			0,1,2,2,1,0,0,1,1,0,0,
			0,1,1,1,0,0,0,1,1,0,0,
		}; mapWidth  = 11
		;  mapHeight = 10
		; playLvl(lvlMap);
	}
	
}

#pragma section _BR_Size
unsigned long BR_Size;
#pragma section


#pragma section _TOP

//****************************************************************************
//  InitializeSystem
//
//  param   :   isAppli   : 1 = Application / 0 = eActivity
//              OptionNum : Option Number (only eActivity)
//
//  retval  :   1 = No error / 0 = Error
//
//****************************************************************************
int InitializeSystem(int isAppli, unsigned short OptionNum)
{
    return INIT_ADDIN_APPLICATION(isAppli, OptionNum);
}

#pragma section

